package org.test

import java.util.function.Supplier

object HOFTest {

  def testFunc[T](supplier: Supplier[T]) = supplier.get()

  def testFuncE[T](supplier: ESupplier[T]) = {
    val o = supplier.get() match {
      case s: String => s + " from ESupplier"
      case i: Int => Int.MaxValue
      case x => x
    }
    o.asInstanceOf[T]
  }

  def testFuncE[T](supplier: ()=>T) = {
    val o = supplier() match {
      case s: String => s + " from Function0"
      case i: Int => Int.MinValue
      case x => x
    }
    o.asInstanceOf[T]
  }

  def callScalaTestFuncE() = {
    testFuncE { () => "Hello" }
  }
}
